//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VCLTee.TeeEdit"
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
  ChartInit();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
  if (SpeedButton1->Down)
    ChartClear();
  Timer1->Enabled = SpeedButton1->Down;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
  ChartEditor1->Execute();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ChartInit(void)
{
  Chart1->Color                 = clWhite;
  Chart1->BackWall->Transparent = true;
  Chart1->Title->Visible        = false;
  Chart1->Legend->Visible       = false;
  Chart1->Hover->Visible        = false;
  Chart1->Gradient->Visible     = false;
  Chart1->Shadow->Visible       = false;
  Chart1->ClipPoints            = true;   // is not working with Series1->AutoRepaint = false

  Chart1->Axes->FastCalc          = true;
  Chart1->Axes->Left->Automatic   = false;
  Chart1->Axes->Bottom->Automatic = false;

  Series1->Clear();
  Series1->Color              = clRed;
  Series1->XValues->Order     = loNone;
  Series1->YValues->Order     = loNone;
//  Series1->FastPen            = true;   // causes wrong color with Series1->AutoRepaint = false
  Series1->FastPen            = false;
  Series1->AutoRepaint        = false;
  Series1->DrawAllPoints      = false;    // causes wrong display with Series1->AutoRepaint = false
  Series1->DrawAllPointsStyle = daMinMax;

  ChartClear();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ChartClear(void)
{
  ChartX = 0.0;
  Series1->Clear();
  Chart1->Axes->Left->SetMinMax(-2.0, 2.0);
  Chart1->Axes->Bottom->SetMinMax(0.0, 10.0);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  static double ChartY = 1.0;

  if (ChartY == 1.0)
    ChartY = -1.0;
  else
    ChartY = 1.0;

  for(unsigned i = 0; i < Timer1->Interval * 10; i++)
  {
    ChartX += 0.0001;
    Series1->AddXY(ChartX, ChartY);
  }
}

//---------------------------------------------------------------------------
